
	.global _CallDynaRecFunction
	.global _CallReturnFromDynaRec
	.global _DirectExitCheck
	.global _IndirectExitCheck

    .set push 
    .set noreorder 
#######################################################################################
#    
_CallDynaRecFunction: 
	addiu	$sp, $sp, -40	# Push return address on the stack
	sw		$fp, 4($sp)		# Store s8 - we use this as our base pointer
	sw		$ra, 0($sp)
	
	sw		$s0, 8($sp)
	sw		$s1, 12($sp)
	sw		$s2, 16($sp)
	sw		$s3, 20($sp)
	sw		$s4, 24($sp)
	sw		$s5, 28($sp)
	sw		$s6, 32($sp)
	sw		$s7, 36($sp)
	
	or		$s7, $a2, $0	# Read address table
	
	jr		$a0				# Jump to our target function
	or		$fp, $a1, $0
	
#######################################################################################
#
_CallReturnFromDynaRec:

	lw		$s0, 8($sp)
	lw		$s1, 12($sp)
	lw		$s2, 16($sp)
	lw		$s3, 20($sp)
	lw		$s4, 24($sp)
	lw		$s5, 28($sp)
	lw		$s6, 32($sp)
	lw		$s7, 36($sp)

	lw		$ra, 0($sp)		# Restore our return address
	lw		$fp, 4($sp)		# And s8
	jr		$ra
	addiu	$sp, $sp, +40
	

#######################################################################################
#	Update counter and exit
#	a0	- instructions executed
#	a1	- exit pc
#	a2	- exit delay
_DirectExitCheck:
	or		$s0, $ra, $0		# Keep track of return addresss
	sw		$a1, 0x400($fp) 	# CurrentPC
	sw		$a2, 0x408($fp)		# Delay
	jal		CPU_UpdateCounter
	nop
	lw		$t0, 0x40c($fp)		# StuffToDo
	bne		$t0, $0, _CallReturnFromDynaRec
	nop
	jr		$s0					# Return back to caller
	nop

#######################################################################################
#	Update counter. If StuffToDo flags is clear on return, 
#	a0 - instructions executed
#	a1 - CIndirectExitMap pointer
#	a2 - exit pc (exit delay is always NO_DELAY)
_IndirectExitCheck:
	or		$s0, $a1, $0		# Keep track of map pointer
	or		$s1, $a2, $0		# and the exit pc

	# Can avoid these until _CallReturnFromDynaRec?	
	sw		$a2, 0x400($fp) 	# CurrentPC
	sw		$0,  0x408($fp)		# Delay (NO_DELAY)
	
	jal		CPU_UpdateCounter	# a0 holds instructions executed
	nop

	lw		$t0, 0x40c($fp)		# StuffToDo
	bne		$t0, $0, _CallReturnFromDynaRec
	nop
	
	or		$a0, $s0, $0		# p_map
	jal		IndirectExitMap_Lookup
	or		$a1, $s1, $0		# exit_pc

	# $v0 holds pointer to indirect target. If it's 0, it means it's not compiled yet
	beq		$v0, $0,  _CallReturnFromDynaRec
	nop
	
	jr		$v0
	nop

#######################################################################################
	.set pop
