// stdafx.h : include file for standard system include files,
//  or project specific include files that are used frequently, but
//      are changed infrequently
//

#ifndef PRECOMPILED_H_
#define PRECOMPILED_H_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//*****************************************************************************
//	These are our various compilation options
//*****************************************************************************
#ifdef DAEDALUS_W32
#ifdef _DEBUG
#define _CRTDBG_MAP_ALLOC
#endif
#endif

//#define DAEDALUS_ENABLE_OS_HOOKS

//#define DAEDALUS_ENABLE_SYNCHRONISATION
#define DAEDALUS_ENABLE_DYNAREC
#define DAEDALUS_ZLIB_SUPPORT				// Undefine this if you don't have a local install of zlib. If you undefine this, you will need to remove unzip.c from the project too.
#define DAEDALUS_USE_EXCEPTIONS
#define DAEDALUS_BREAKPOINTS_ENABLED

#ifdef DAEDALUS_PSP
//#undef DAEDALUS_ENABLE_DYNAREC
#undef DAEDALUS_USE_EXCEPTIONS
#undef DAEDALUS_BREAKPOINTS_ENABLED
#endif

//*****************************************************************************
//
//*****************************************************************************
#define WIN32_LEAN_AND_MEAN		// Exclude rarely-used stuff from Windows headers


#ifdef _MSC_VER
// BEGIN ADDED BY Lkb - 8/jun/2001
#pragma warning(disable : 4786)	// identifier was truncated to '255' characters in the debug information ?
// END ADDED BY Lkb

#define __PRETTY_FUNCTION__ __FUNCTION__

#endif

#if !defined( DAEDALUS_XB ) && defined( DAEDALUS_RELEASE_BUILD )
#define DAEDALUS_ALIGN_REGISTERS
#endif

#ifdef _DEBUG

#define NODEFAULT		DAEDALUS_ASSERTMSG( "No default - we shouldn't be here" )

#else

#define NODEFAULT		__assume( 0 )

#endif

#ifdef DAEDALUS_PSP



typedef char TCHAR;
typedef char * LPTSTR;
typedef char * LPSTR;
typedef const char * LPCSTR;
typedef const char * LPCTSTR;
#define MAX_PATH 260
#define __cdecl        //No meaning on the PSP __attribute__((cdecl))
#define __fastcall     //No meaning on the PSP __attribute__((fastcall))
#define __stdcall      //No meaning on the PSP __attribute__((stdcall))
#define __forceinline	inline
#define __assume( x )
#define __declspec( x )

typedef long BOOL;
#define FALSE 0
#define TRUE 1

typedef int HRESULT;
typedef unsigned int DWORD;
typedef char CHAR;

typedef unsigned char BYTE;
typedef short WORD;
typedef int* HWND;
typedef int* HINSTANCE;
typedef int* HANDLE;


#else
#include <atlbase.h>
extern CComModule _Module;
#include <atlcom.h>
#include <atlwin.h>
#include <windows.h>
#include <windowsx.h>
#include <winnt.h>			// For 32x32To64 multiplies
#include <commctrl.h>
#include <commdlg.h>
#include <shellapi.h>		// ShellExecute()
#include <shlobj.h>

#include <oleauto.h> // BSTR

#include <algorithm>
#include <vector>
#include <map>
#include <string>

#endif

#include <stdio.h>
#include <math.h>			// For sqrt()
#include <stdlib.h>
#include <string.h>

#ifdef DAEDALUS_W32
#include <crtdbg.h>

#ifdef _DEBUG
#ifndef NEW_INLINE_WORKAROUND
#define NEW_INLINE_WORKAROUND new ( _NORMAL_BLOCK, __FILE__, __LINE__ )
#define new NEW_INLINE_WORKAROUND
#endif // NEW_INLINE_WORKAROUND
#endif // _DEBUG
#endif // DAEDALUS_W32


#define use(x)	do { } while(&(x) != &(x))


#include "Debug\DaedalusAssert.h"
#include "DaedalusTypes.h"

using namespace daedalus;

#ifndef SAFE_DELETE
#define SAFE_DELETE(p)  { if(p) { delete (p);     (p)=NULL; } }
#endif

#ifndef SAFE_RELEASE
#define SAFE_RELEASE(p)  { if(p) { (p)->Release();     (p)=NULL; } }
#endif

#ifndef SAFE_DELETEARRAY
#define SAFE_DELETEARRAY(p)  { if(p) { delete [](p);     (p)=NULL; } }
#endif

#define ARRAYSIZE(arr)   (sizeof(arr) / sizeof(arr[0]))

#define DAEDLAUS_VERSION_NO		0x008b
#define DAEDALUS_VERSION		"0.08b"
#define DAEDALUS_SITE			"http://strmnnrmn.blogspot.com/"

// DAEDALUS_RELEASE_BUILD is now only defined for "Win32 Release" configuration
// It is disabled in Win32 Development Release etc

extern const TCHAR * __cdecl DSPrintf( const TCHAR * fmt, ... );

#ifndef DAEDALUS_PSP
extern HINSTANCE	g_hInstance;
#endif
extern TCHAR		g_szDaedalusName[256];
extern TCHAR		g_szDaedalusExeDir[MAX_PATH+1];

#include "ConfigOptions.h"

#define ALIGNED_TYPE(type, alignval) type
#define ALIGNED_EXTERN(type, var, alignval) extern type var
#define ALIGNED_GLOBAL(type, var, alignval) type var
#define ALIGNED_MEMBER(type, var, alignval) type var

#if defined(DAEDALUS_W32) || defined(DAEDALUS_XB)

#ifdef _MSC_VER
#if defined(_MSC_FULL_VER) && (_MSC_FULL_VER >= 12008804) 
#undef ALIGNED_TYPE
#undef ALIGNED_GLOBAL
#undef ALIGNED_MEMBER
#define ALIGNED_TYPE(type, alignval) __declspec(align(alignval)) type
#define ALIGNED_GLOBAL(type, var, alignval) __declspec(align(alignval)) type var
#define ALIGNED_MEMBER(type, var, alignval) __declspec(align(alignval)) type var
#else
#pragma message("You should install Microsoft Visual C++ 6.0 Service Pack 5 and Processor Pack (both free of charge)")
#endif
#endif

#ifdef __GNUC__
// GCC has __attribute__((aligned)) but it complains that the maximum alignment is 16
#undef ALIGNED_GLOBAL
#undef ALIGNED_MEMBER
#define ALIGNED_GLOBAL(type, var, alignval) __asm__(".balign " #alignval ) type var;
#define ALIGNED_MEMBER(type, var, alignval) __attribute__((aligned(alignval))) type var;
#endif
#endif // defined(DAEDALUS_W32) || defined(DAEDALUS_XB)

// Pentium 4 has 64-byte cachelines
#define DATA_ALIGN	16
#define CACHE_ALIGN	64
#define PAGE_ALIGN	4096


// Windowsx.h type defines - hope these don't conflict with anything!
#define CheckBox_GetCheck(hwnd)			SendMessage(hwnd, BM_GETCHECK, 0,0)
#define CheckBox_SetCheck(hwnd, state)	SendMessage(hwnd, BM_SETCHECK, (WPARAM)state,0)

#define CheckBox_IsChecked( hwnd )		(CheckBox_GetCheck( (hwnd) ) == BST_CHECKED)

#endif // PRECOMPILED_H_
